﻿; AutoHotkey用キーストローク生成 / generate keystrokes for AHK
; last update: 2011/11/4

#SingleInstance, force
#Installkeybdhook

modkeylist = Ctrl|Shift|Alt|RWin|LWin

;キーリスト / Create key list
keylist =
(
A|B|C|D|E|F|G|H|I|J|K|L|M|N|O|P|Q|R|S|T|U|V|W|X|Y|Z|0|1|2|3|4|5|6|7|8|9|
Enter|Space|BackSpace|Esc|Tab|Up|Down|Left|Right|
Delete|Insert|Home|End|PgUp=PageUp|PgDn=PageDown|ScrollLock|CapsLock|NumLock|
Numpad0|Numpad1|Numpad2|Numpad3|Numpad4|Numpad5|Numpad6|Numpad7|Numpad8|Numpad9|
NumpadDot=Num(.)|NumpadDiv=Num(/)|NumpadMult=Num(*)|
NumpadAdd=Num(+)|NumpadSub=Num(-)|NumpadEnter|
NumpadIns|NumpadEnd|NumpadDown|NumpadPgDn|NumpadLeft|NumpadClear|
NumpadRight|NumpadHome|NumpadUp|NumpadPgUp|NumpadDel|
LButton|RButton|MButton|WheelUp|WheelDown|WheelLeft|WheelRight|
F1|F2|F3|F4|F5|F6|F7|F8|F9|F10|F11|F12|
F13|F14|F15|F16|F17|F18|F19|F20|F21|F22|F23|F24|
AppsKey|PrintScreen|CtrlBreak|Pause|Break|,|.|/|\|:|]|@|[|-|^|;|
Browser_Back|Browser_Forward|Browser_Refresh|Browser_Stop|
Browser_Search|Browser_Favorites|Browser_Home|
Volume_Mute|Volume_Down|Volume_Up|
Media_Next|Media_Prev|Media_Stop|Media_Play_Pause|
Launch_Mail|Launch_Media|Launch_App1|Launch_App2
)

;for Japanese Keyboard
If (A_Language == 0411)
	keylist .= "|sc07B=無変換|sc079=変換|sc073=(バックスラッシュ)"
;以下のキーは問題があるため使用しない
;	sc070=カタカナひらがな

StringReplace, keylist, keylist, `n,, All
gosub, SetHotkeys

;Gui作成 / Create GUI
;for Japanese User
If (A_Language == 0411) {

	Gui, Add, Text,, % "入力キー"
	Gui, Add, Edit, w250 vCtlInputKey, % "キーを押してください"

	Gui, Add, GroupBox, y+20 w250 h50, % "一度押せばいいキーの場合"

	Gui, Add, Text, xp+10 yp+22, % "DownKey="
	Gui, Add, Edit, x75 yp-4 w135 vCtlOnceKey
	Gui, Add, Button, X+0 yp-2 w40 vCtlOnceKeyCopy gBtnCopy, % "Copy"

	Gui, Add, GroupBox, xm y+27 w250 h70, % "押し続けるキーの場合"
}
;for English User
else {
	Gui, Add, Text,, % "Input Key(s)"
	Gui, Add, Edit, w250 vCtlInputKey, % "Press any key(s)"

	Gui, Add, GroupBox, y+20 w250 h50, % "for Keys pressed once"

	Gui, Add, Text, xp+10 yp+22, % "DownKey="
	Gui, Add, Edit, x75 yp-4 w135 vCtlOnceKey
	Gui, Add, Button, X+0 yp-2 w40 vCtlOnceKeyCopy gBtnCopy, % "Copy"

	Gui, Add, GroupBox, xm y+27 w250 h70, % "for Keys held down"
}

Gui, Add, Text, xp+10 yp+22, % "DownKey="
Gui, Add, Edit, x75 yp-4 w135 vCtlDownKey
Gui, Add, Button, X+0 yp-2 w40 vCtlDownKeyCopy gBtnCopy, % "Copy"

Gui, Add, Text, xm+10 yp+29, % "UpKey="
Gui, Add, Edit, x75 yp-4 w135 vCtlUpKey
Gui, Add, Button, X+0 yp-2 w40 vCtlUpKeyCopy gBtnCopy, % "Copy"

Gui, Add, Button, x95 y+20 w80 gGuiClose, OK
Gui, Show


Return

;OKボタンを押す／ウィンドウを閉じるで終了 / Exit app if [OK] button pressed or window closed.
GuiClose:
	ExitApp

;Copyボタン処理 / Proccess [Copy] buttons.
BtnCopy:
	Gui, Submit, NoHide
	StringReplace, ctl, A_GuiControl, Copy
	Clipboard := %ctl%
	Return

;キー監視登録 / Register keys.
SetHotkeys:
	Hotkey, IfWinActive, %A_ScriptName%	ahk_class AutoHotkeyGUI
	Loop, PARSE, modkeylist, |
	{
		If (A_LoopField)
			Hotkey, ~*%A_LoopField%, AnyKey_down
	}
	Loop, PARSE, keylist, |
	{
		keysrc := A_LoopField
		;マウスボタンはスルー
		If keysrc in LButton,RButton,MButton
			keysrc := "~" keysrc
		If (RegExMatch(keysrc, "(.+?)=(.*)", match)) {
			HotKey, *%match1%, AnyKey_down
			match1 := ConvertVariableName(match1)
			KeyInfo_%match1% := match2
		}
		Else
			Hotkey, *%keysrc%, AnyKey_down
	}
	return

;キー名を変数名として利用するためAsciiコードに変換
ConvertVariableName(str)
{
	While (RegExMatch(str, "[^A-Za-z0-9]", c))
		str := RegExReplace(str, "\" c, "Asc" Asc(c))
	Return str
}

;キー処理 / Process keys.
AnyKey_down:
	ThisHotkey := RegExReplace(A_ThisHotkey, "^~")
;	If (InStr(modkeylist, ThisHotkey))
;		ThisHotkey := ""
	;入力キーコントロール以外では反応しない / React only Edit control activated.
	ControlGetFocus, ctl, A
	If (ctl != "Edit1") {
		Send, % "{Blind}{" RegExReplace(ThisHotkey, "^\*") "}"
		Return
	}
	;マウスボタンはコントロール上でのみ入力可能 / Proc Mouse buttons
	If (InStr(ThisHotkey, "Button")) {
		MouseGetPos,,,, ctl
		If (ctl != "Edit1") {
			Return
		}
		Else
			StringReplace, ThisHotkey, ThisHotkey, ~
	}
	;キー名取得 / Get Keyname
	Key := RegExReplace(ThisHotkey, "\*(.*)", "$1")	;AHK用キー名
	Key1 := ConvertVariableName(Key)
	KeyName := KeyInfo_%key1% ? KeyInfo_%key1% : Key	;表示用キー名
	;アルファベットは小文字にする / Convert captital letter to small.
	If (StrLen(key) == 1)
		StringLower, key, key
	;{}で囲む必要のあるキー
	If (StrLen(key) > 1 || InStr("!#+^{}", key))
			key := "{" key "}"
	;修飾キー状態取得 / Get modifier keys' status.
	mod_ctrl := GetKeyState("Ctrl", "P") & (KeyName != "Ctrl")
	mod_shift := GetKeyState("Shift", "P") & (KeyName != "Shift")
	mod_alt := GetKeyState("Alt", "P") & (KeyName != "Alt")
	mod_win := (GetKeyState("LWin", "P") || GetKeyState("RWin", "P")) & (KeyName != "LWin" || KeyName != "LWin")
	;表示用修飾キー状態 / Modifier keys for displaying.
	InputMod := (mod_ctrl ? "Ctrl + ": "") (mod_shift ? "Shift + " : "")
	          . (mod_alt ? "Alt + " : "") (mod_win ? "Win + " : "")
	;Ahk修飾キー状態 / Modifier keys for AHK keystrokes.
	AhkMod := (mod_ctrl ? "^": "") (mod_shift ? "+" : "")
	        . (mod_alt ? "!" : "") (mod_win ? "#" : "")
	GuiControl,, CtlInputKey, %InputMod%%KeyName%
	GuiControl,, CtlOnceKey, %AhkMod%%key%
	;押し続けるキー用変換 / for Keys held down.
	If (!InStr(key, "}"))
		key := "{" key "}"
	StringReplace, downkey, key, }, % " Down}"
	StringReplace, upkey, key, }, % " Up}"
	AhkMod_downkey := (mod_ctrl ? "{Ctrl Down}" : "") (mod_shift ? "{Shift Down}" : "")
	                . (mod_alt ? "{Alt Down}" : "") (mod_win ? "{Win Down}" : "")
	AhkMod_upkey := (mod_win ? "{Win Up}" : "") (mod_alt ? "{Alt Up}" : "")
	              . (mod_shift ? "{Shift Up}" : "") (mod_ctrl ? "{Ctrl Up}" : "")
	GuiControl,, CtlDownKey, %AhkMod_downkey%%downkey%
	GuiControl,, CtlUpKey, %upkey%%AhkMod_upkey%
	return

